﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace name_change_gui
{
    public partial class main_gui : Form
    {
        string pfad;
        //bool recusives_einlesen;
        string seach_nach;
        string replace_mit;
        bool pfadexist = false;
        DirectoryInfo filelist;
        DirectoryInfo dir;
        static int dirCounter = 1;
        static int fileCounter = 0;
        static string filelistrecu = "";


        public main_gui()
        {
            InitializeComponent();

        }

        private void button_input_pfad_Click(object sender, EventArgs e)
        {
            if (Dialog_input_folder.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                pfad = Dialog_input_folder.SelectedPath;
                textBox_input_pfad.Text = Dialog_input_folder.SelectedPath;
                pfadexist = true;
            }
            else
            {
                pfadexist = false;
            }
        }

        private void button_start_Click(object sender, EventArgs e)
        {
            textBox_ausgabe.Text = "";
            bool su_er = false;

            if (textBox_input_pfad.Text != "")
            {
                pfadexist = true;
            }
            else
            {
                pfadexist = false;
            }

            if (checkBox_suchen_ersetzen_aktiviren.Checked == true)
            {
                if (textBox_input_replace_with.Text != "" && textBox_input_seach_for.Text != "")
                {
                    su_er = true;
                }
                else
                {
                    textBox_ausgabe.Text += "FEHLER: Sie haben das Suchen und Ersetzen aktiviert\r\naber haben nicht alle angaben ausgefüllt!\r\n";
                    su_er = false;
                }
            }
            else
            {
                su_er = true;
            }

            if (checkBox_recu.Checked == true)
            {
                if (pfadexist == true)
                {
                    ExploreDirectory(new DirectoryInfo(textBox_input_pfad.Text));

                    seach_nach = textBox_input_seach_for.Text;
                    replace_mit = textBox_input_replace_with.Text;

                    string tempname;
                    string endung;
                    string punktstr;
                    string dest = pfad;
                    string dir = "";
                    int i;
                    //recusives_einlesen = checkBox_recu.Checked;
                    string [] filelistrecuAr = filelistrecu.Split('*');
                    foreach (string file in filelistrecuAr)
                    {
                        if (file != "")
                        {
                            int pos = file.LastIndexOf('\\');
                            dir = file.Remove(pos);
                            tempname = file;
                            endung = file.Remove(0, pos + 1);

                            //i = endung.Length - 1;
                            punktstr = "";

                            if (endung.IndexOf('.') > 0)
                            {
                                for (i = endung.IndexOf('.'); i <= endung.Length - 1; i++)
                                {
                                    punktstr += endung[i];
                                }
                                endung = endung.Replace(punktstr, "");
                            }

                            if (radioButton_klein_schreiben.Checked == true) endung = endung.ToLower();
                            if (checkBox_suchen_ersetzen_aktiviren.Checked == true) endung = endung.Replace(seach_nach, replace_mit);

                            if (checkBox_ae.Checked == true)
                            {
                                endung = endung.Replace("ä", "ae");
                                endung = endung.Replace("Ä", "Ae");
                            }
                            if (checkBox_oe.Checked == true)
                            {
                                endung = endung.Replace("ö", "oe");
                                endung = endung.Replace("Ö", "Oe");
                            }
                            if (checkBox_ue.Checked == true)
                            {
                                endung = endung.Replace("ü", "ue");
                                endung = endung.Replace("Ü", "Ue");
                            }
                            if (checkBox_und.Checked == true)
                            {
                                endung = endung.Replace("&", "und");
                            }
                            if (checkBox_ss.Checked == true)
                            {
                                endung = endung.Replace("ß", "ss");
                            }

                            if (radioButton_gross_schreiben.Checked == true) endung = endung.ToUpper();

                            textBox_ausgabe.Text += file + "\r\nbennenen zu\r\n" + dir + '\\' + endung + punktstr + "\r\n\r\n";

                            File.Move(file, dir + '\\' + endung + punktstr);
                        }
                    }
                    

                }
                else
                {
                    textBox_ausgabe.Text += "FEHLER: Sie müssen einen Pfad angeben!\r\n";
                }
            }
            else
            {

                if (pfadexist == true && su_er == true)
                {
                    //recusives_einlesen = checkBox_recu.Checked;
                    seach_nach = textBox_input_seach_for.Text;
                    replace_mit = textBox_input_replace_with.Text;

                    string tempname;
                    string endung;
                    string punktstr;
                    string dest = pfad;
                    int i;

                    filelist = new DirectoryInfo(pfad);
                    FileInfo[] MyFiles = filelist.GetFiles();

                    foreach (FileInfo F in MyFiles)
                    {
                        tempname = F.Name;
                        endung = F.Name;
                        i = endung.Length - 1;
                        punktstr = "";

                        if (endung.IndexOf('.') > 0)
                        {
                            for (i = endung.IndexOf('.'); i <= endung.Length - 1; i++)
                            {
                                punktstr += endung[i];
                            }
                            tempname = tempname.Replace(punktstr, "");
                        }

                        if (radioButton_klein_schreiben.Checked == true) tempname = tempname.ToLower();
                        if (checkBox_suchen_ersetzen_aktiviren.Checked == true) tempname = tempname.Replace(seach_nach, replace_mit);

                        if (checkBox_ae.Checked == true)
                        {
                            tempname = tempname.Replace("ä", "ae");
                            tempname = tempname.Replace("Ä", "Ae");
                        }
                        if (checkBox_oe.Checked == true)
                        {
                            tempname = tempname.Replace("ö", "oe");
                            tempname = tempname.Replace("Ö", "Oe");
                        }
                        if (checkBox_ue.Checked == true)
                        {
                            tempname = tempname.Replace("ü", "ue");
                            tempname = tempname.Replace("Ü", "Ue");
                        }
                        if (checkBox_und.Checked == true)
                        {
                            tempname = tempname.Replace("&", "und");
                        }
                        if (checkBox_ss.Checked == true)
                        {
                            tempname = tempname.Replace("ß", "ss");
                        }

                        if (radioButton_gross_schreiben.Checked == true) tempname = tempname.ToUpper();

                        textBox_ausgabe.Text += F.Name + "\r\nbennenen zu\r\n" + tempname + punktstr + "\r\n\r\n";
                        dest = pfad;
                        dest += "\\";
                        dest += tempname;
                        dest += punktstr;
                        F.MoveTo(dest);
                    }

                }
                else
                {
                    textBox_ausgabe.Text += "FEHLER: Sie müssen einen Pfad angeben!\r\n";
                }
            }
        }

        private void checkBox_suchen_ersetzen_aktiviren_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox_suchen_ersetzen_aktiviren.Checked == true)
            {
                textBox_input_replace_with.Enabled = true;
                textBox_input_seach_for.Enabled = true;
            }
            else
            {
                textBox_input_replace_with.Enabled = false;
                textBox_input_seach_for.Enabled = false;
            }
        }

        private static void ExploreDirectory(DirectoryInfo dir)
        {
            FileInfo[] filesInDir = dir.GetFiles();
            foreach (FileInfo file in filesInDir)
            {
                filelistrecu += file.FullName + '*';
                fileCounter++;
            }
            DirectoryInfo[] directories = dir.GetDirectories();
            foreach (DirectoryInfo newDir in directories)
            {
                dirCounter++;  // increment the counter
                ExploreDirectory(newDir);
            }
        }
    }
}
